<template>
  <div
    class="min-h-full flex flex-col items-center justify-center py-12 px-4 sm:px-6 lg:px-8"
  >
    <div class="max-w-7xl w-full bg-white p-4 md:px-8 shadow-xl">
      <div :key="index" v-for="(step, index) in roadtrip.stepsAToB">
        <Vuemik
          class="space-y-6"
          v-slot="{ values, handleSubmit }"
          v-show="index === roadtrip.currentStep"
          :initial-values="roadtrip.generateStepAToBInitialValue(step)"
          :on-submit="(values) => roadtrip.submitStepAToB(values, step)"
        >
          <fieldset>
            <div class="mb-5 md:flex md:flex-row md:justify-center relative text-center">
              <div class="md:absolute left-0">
                <Button
                  @click="roadtrip.reSubmitRoadtrip()"
                  label="Recalculer ce roadtrip"
                />
              </div>

              <div class="w-full my-3 md:my-0">
                <h1 class="text-3xl font-extrabold text-gray-900">
                  Jour {{ step.nbDay }}
                </h1>
              </div>
            </div>
            
            <div class="rounded-md">
              <div class="my-5">
                <h3 class="text-yellow-600 font-bold">Restaurants :</h3>
                <div class="lg:flex lg:items-stretch gap-8">
                  <div
                    class="w-full lg:w-1/3"
                    v-for="restaurant in step.restaurants"
                    :key="restaurant.id"
                  >
                    <RadioField
                      name="restaurant"
                      :value="restaurant.id"
                      :label="restaurant.name"
                      :description="restaurant.tags.map(tag => translation.displayTagOrCategory(tag, 'tag')).join(', ')"
                      :checked="restaurant.id === values.restaurant"
                      @input="values.restaurant = $event.target.value"
                    />
                  </div>
                </div>
                <h4 v-show="step.restaurants.length === 0">
                  Aucun restaurant trouvé
                </h4>
              </div>

              <div v-if="step.hostels !== undefined" class="mb-5">
                <h3 class="text-yellow-600 font-bold">Hôtels :</h3>
                <div class="lg:flex lg:items-stretch gap-8">
                  <div
                    class="w-full lg:w-1/3"
                    v-for="hostel in step.hostels"
                    :key="hostel.id"
                  >
                    <RadioField
                      name="hostel"
                      :value="hostel.id"
                      :label="hostel.name"
                      :description="hostel.categorySet.map(categoryId => translation.displayTagOrCategory(categoryId, 'category')).join(', ')"
                      :checked="hostel.id === values.hostel"
                      @input="values.hostel = $event.target.value"
                    />
                  </div>
                </div>
                <h4 v-show="step.hostels.length === 0">Aucun hôtel trouvé</h4>
              </div>

              <div
                class="grid"
                :class="roadtrip.currentStep > 0 ? 'grid-cols-2' : ''"
              >
                <button
                  v-show="index > 0"
                  class="justify-self-start py-2 px-4 text-sm font-medium rounded-md text-white bg-yellow-500 hover:bg-yellow-600"
                  @click.prevent="roadtrip.prevStepAToB()"
                >
                  Précédent
                </button>
                <button
                  v-show="index < roadtrip.stepsAToB.length - 1"
                  class="justify-self-end py-2 px-4 text-sm font-medium rounded-md text-white bg-yellow-500 hover:bg-yellow-600"
                  @click.prevent="handleSubmit"
                >
                  Suivant
                </button>
                <button
                    v-show="index === roadtrip.stepsAToB.length - 1"
                    class="py-2 px-4 text-sm font-medium rounded-md text-white bg-yellow-500 hover:bg-yellow-600"
                    @click.prevent="handleSubmit"
                >
                  Valider
                </button>
              </div>
            </div>
          </fieldset>
        </Vuemik>
      </div>
      <p class="text-center">
        Un choix automatique sera fait pour vous si vous ne choisissez pas
        d'hôtel ou de restaurant.
      </p>
    </div>
  </div>
</template>

<script>
import RadioField from "@/components/Form/RadioField.vue";
import Button from "@/components/Button";

export default {
  name: "AtoBStepForm",
  inject: ["roadtrip","translation"],
  beforeMount() {
    if (this.roadtrip.stepsAToB === null) {
      this.$router.push("/");
    }
  },
  components: {
    RadioField,
    Button
  },
};
</script>
